<?php

/************************************************************************/
/* Bookmark4U: Web-based personal bookmarking environment               */
/* ======================================================               */
/* Please read LICENSE.txt                                              */
/************************************************************************/

$env[include_prefix] = "..";
$env[pass_without_login] = 1;
include("../inc/common.php");

include("../sql/sql.mysql.php");

if ($HTTP_SERVER_VARS[REQUEST_METHOD] == 'GET') {
  $mode       = $HTTP_GET_VARS[mode];
  $uid        = $HTTP_GET_VARS[uid];
} elseif ($HTTP_SERVER_VARS[REQUEST_METHOD] == 'POST') {
  $mode       = $HTTP_POST_VARS[mode];
  $pw         = $HTTP_POST_VARS[pw];
  $pw1        = $HTTP_POST_VARS[pw1];
  $pw2        = $HTTP_POST_VARS[pw2];
  $uid        = $HTTP_POST_VARS[uid];
  $autopasswd = $HTTP_POST_VARS[autopasswd];
  $sendmail   = $HTTP_POST_VARS[sendmail];
}

function Head1() {
  global $HTTP_SERVER_VARS;
  global $env;

  echo("<html>
<head>
<style type='text/css'>
a:link    { text-decoration:none; }
a:visited { text-decoration:none; }
a:hover   { text-decoration:underline; }
td,body   {
  color: black;
  font-family: Verdana,Arial,Helvetica;
  font-size: x-small;
}
input,select,textarea {
  border:1 solid black;
  background-color: #eeeeee;
  color:black;
}
</style>
<title>Bookmark4U</title>
</head>
<body bgcolor=white text=black link=#aa4444 alink=#aa4444 vlink=#aa4444");
  if ($env[page_focus]) echo(" onLoad=\"javascript:PageFocus()\"");
  echo(">
<center>
<b>Bookmark4U Administrator's Home</b><br>
<a href='../index.php'>Bookmark4U</a> |
<a href='index.php'>Admin Home</a> |
<a href='index.php?mode=dbstat'>Databases statistic</a> |
<a href='$HTTP_SERVER_VARS[PHP_SELF]?mode=chpwform'>Change admin password</a>
<br>
<a href='config.php'>Database Configuration</a> |
<a href='index.php?mode=logout'>Admin Logout</a>
<br><br>
</center>\n");
}

function Tail1() {
  echo("</body></html>\n");
}

function GetAdminPassword($hidden_tags='', $button_str='OK', $prompt='') {
  global $HTTP_SERVER_VARS;

  echo("<table border=0 align=center>
  <form action='$HTTP_SERVER_VARS[PHP_SELF]' method='post' name='loginform'>
  <tr>
    <td align='center' colspan='2'>$prompt</td>
  </tr>
  <tr>
    <td align=right>Admin Password :</td>
    <td><input type='password' name='pw' size='12'></td>
  </tr>
  <tr>
    <td align=right></td>
    <td>
      $hidden_tags
      <input type='submit' value='$button_str'>
    </td>
  </tr>
  </form></table>\n");
}

# check if PASSWD_TEMP table exists in database, and
# check an admin account exists in the PASSWD table.
function CheckDB() {
  global $env;
  $qry = "SELECT * FROM $env[dbtblpasswdtmp]";
  $ret = DBQuery($qry);
  DBError();
  if (!$ret) {
    $msg = "Table '$env[dbtblpasswdtmp]' does not exist in database.\\n"
          ."Please make table '$env[dbtblpasswdtmp]'. Refer UPGRADE.txt.";
    Error("$msg");
  }

  $qry = "SELECT * FROM $env[dbtblpasswd] WHERE user='admin'";
  $ret = DBQuery($qry);
  DBError();
  if (!$ret) {
    $msg = "An 'admin' user does not exist in the table '$env[dbtblpasswd]'\\n"
          ."Please insert a row for 'admin'. Refer UPGRADE.txt.";
    Error("$msg");
  }
}

if ($mode == 'logout') {
  ClearCookies();
  header("Location: $HTTP_SERVER_VARS[PHP_SELF]?dummy=$env[dummy]");
  exit;
}

# check authorization
$admin_token = GetCookie("ADMIN");
if ($admin_token == '') {
  if ($mode == 'adminlogin') {
    CheckDB();
    $qry = "SELECT * FROM $env[dbtblpasswd]
       WHERE user='admin' AND passwd=PASSWORD('$pw')";
    $row = DBQueryAndFetchRow($qry);
    DBError();
    if (!$row) Error("Incorrect admin password");
    $t = time();
    PutCookie("ADMTIME", $t);
    $token = md5("$t:$conf[static_cookie]:$conf[dbname]");
    PutCookie("ADMIN", $token);
    if ($pw == 'test') {
      ErrorRedir("Please change admin password", "$HTTP_SERVER_VARS[PHP_SELF]?mode=chpwform");
    } else {
      header("Location: $HTTP_SERVER_VARS[PHP_SELF]");
    }
    exit;
  } else {
    $env[page_focus] = 1;
    Head1();
    $hidden_tags = "<input type='hidden' name='mode' value='adminlogin'>";
    $prompt = "Enter admin password to login";
    GetAdminPassword($hidden_tags, 'Login', $prompt);
    echo("<script>
  function PageFocus() { document.loginform.pw.focus(); }
</script>\n");
    Tail1();
    exit;
  }
} else {
  $t = GetCookie('ADMTIME');

  if ($admin_token != md5("$t:$conf[static_cookie]:$conf[dbname]")) {
    ErrorRedir("Access denied", "index.php?mode=logout");
    exit;
  }
}


if ($mode == 'register') {

  # fetch from PASSWD_TEMP
  $qry1 = "SELECT * FROM $env[dbtblpasswdtmp] WHERE uid='$uid'";
  $row1 = DBQueryAndFetchRow($qry1);
  DBError();

  # generate a random password
  if ($autopasswd) {
    $rand = rand(1, $env[dummy]);
    $hash = md5($rand);
    $new_pw = substr($hash, 0, 8);  # new password
    $passwd_sql = "passwd=PASSWORD('$new_pw')";
  } else {
    $passwd_sql = "passwd='$row1[passwd]'";
  }

  # insert into PASSWD table
  $qry2 = "INSERT INTO $env[dbtblpasswd] SET user='$row1[user]',
     $passwd_sql,name='$row1[name]',email='$row1[email]',
     lastlogin='',lastip='',logincnt=0,rdate=NOW()";
  $ret2 = DBQuery($qry2);
  DBError();

  # delete from PASSWORD_TEMP table
  $qry3 = "DELETE FROM $env[dbtblpasswdtmp]
     WHERE user='$row1[user]' AND uid='$uid'";
  $ret3 = DBQuery($qry3);
  DBError();

  # get the uid value from PASSWD
  $qry4 = "SELECT * FROM $env[dbtblpasswd] WHERE user='$row1[user]'";
  $row4 = DBQueryAndFetchRow($qry4);
  DBError();

  # insert into CONFIG
  $qry5 = "INSERT INTO $env[dbtblconfig]
          SET uid=$row4[uid], memo='', config=''";
  $ret5 = DBQuery($qry5);
  DBError();

  # user table name
  $user_table = $conf[userdb_prefix].$row1[user];

  # create user bookmark database
  $qry6 = ereg_replace("%NAME%", "$user_table", $sql_cmds[table_user]);
  $ret6 = DBQuery($qry6);
  DBError();

  # insert a sample bookmark
  $qry7 = "INSERT INTO $user_table SET id=1,type='b',parent=0,title='Bookmark4U',url='http://bookmark4u.sourceforge.net',comment='Welcome to Bookmark4U',rdate=NOW(),visit=0,public=1,lastvisit='',lastwhere='',total=1";
  $ret7 = DBQuery($qry7);
  DBError();

  # send an e-mail
  if ($sendmail) {
    $subject = "Bookmark4U registration completed";
    $msg = "'$row1[user]' has been registered in Bookmark4U. Enjoy it.\n";
    if ($autopasswd) { # password has been updated
      $msg .= "A new password has been set as '$new_pw' for you.\n";
    }
    # send an email to the user
    $header = "From: Bookmark4U<$env[admin_email]>\n";
    if ($row1[email]) mail($row1[email], $subject, $msg, $header);
  }

  ErrorRedir("$row1[name] has been registered", "$HTTP_SERVER_VARS[PHP_SELF]");
  exit;

} elseif ($mode == 'registerform') {

  $qry = "SELECT * FROM $env[dbtblpasswdtmp] WHERE uid='$uid' ";
  $row = DBQueryAndFetchRow($qry);
  DBError();

  Head1();
  echo("<script>
function click_sendmail() {
}
function click_autopasswd() {
  if (document.form.autopasswd.checked && !document.form.sendmail.checked) {
    alert('You should send the new password to the user by an email');
    document.form.sendmail.checked = 1;
  }
}
</script>
  <table border='0' align='center'>
  <form action='$HTTP_SERVER_VARS[PHP_SELF]' method='post' name='form'>
  <tr>
   <td align='center'>
    Register '<b>$row[user]</b>' as a normal user?
   </td>
  </tr><tr>
   <td align='left'>
    <input type='checkbox' name='sendmail' value='1' checked
    onClick=\"javascript:click_sendmail();\">
    Send an email to this user about the completion of registration.
   </td>
  </tr><tr>
   <td align='left'>
    <input type='checkbox' name='autopasswd' value='1'
    onClick=\"javascript:click_autopasswd();\">
    Generate a random password for this user.
   </td>
  </tr><tr>
   <td align='center'>
    <input type='hidden' name='mode' value='register'>
    <input type='hidden' name='uid' value='$uid'>
    <input type='submit' value='Register'>
   </td>
  </tr></form></table>\n");
  Tail1();
  exit;

} elseif ($mode == 'del') {
  $qry1 = "SELECT * FROM $env[dbtblpasswd] WHERE user='admin' AND passwd=PASSWORD('$pw')";
  $row1 = DBQueryAndFetchRow($qry1);
  if (!$row1) Error("Incorrect admin password");

  $qry2 = "SELECT * FROM $env[dbtblpasswd] WHERE uid='$uid'";
  $row2 = DBQueryAndFetchRow($qry2);

  # drop user table
  $user_table = $conf[userdb_prefix].$row2[user];
  $qry3 = "DROP TABLE $user_table";
  $ret3 = DBQuery($qry3);
  DBError();

  # delete a record from passwd table
  $qry4 = "DELETE FROM $env[dbtblpasswd] WHERE uid='$row2[uid]'";
  $ret4 = DBQuery($qry4);
  DBError();

  # delete a record from config table
  $qry5 = "DELETE FROM $env[dbtblconfig] WHERE uid='$row2[uid]'";
  $ret5 = DBQuery($qry5);
  DBError();

  # delete records from trash table
  $qry6 = "DELETE FROM $env[dbtbltrash] WHERE user='$row2[user]'";
  $ret6 = DBQuery($qry6);
  DBError();

  # delete records from calendar table
  $qry7 = "DELETE FROM $env[dbtblcalendar] WHERE uid='$row2[uid]'";
  $ret7 = DBQuery($qry7);
  DBError();

  ErrorRedir("$row2[user] has been deleted", "$HTTP_SERVER_VARS[PHP_SELF]");
  exit;

} elseif ($mode == 'delform') {

  $env[page_focus] = 1;
  Head1();
  $hidden_tags = "<input type='hidden' name='mode' value='del'>"
                ."<input type='hidden' name='uid' value='$uid'>";
  $prompt = "Enter admin password to delete user (uid=$uid)";
  GetAdminPassword($hidden_tags, 'Delete', $prompt);
  echo("<script>
  function PageFocus() { document.loginform.pw.focus(); }
</script>\n");
  Tail1();
  exit;

} elseif ($mode == 'chpw') {
  if (!$pw1 || !$pw2 || $pw1 != $pw2) Error("New passwords does not match");

  $qry = "SELECT * FROM $env[dbtblpasswd] WHERE user='admin' AND passwd=PASSWORD('$pw')";
  $row = DBQueryAndFetchRow($qry);
  if (!$row) Error("Incorrect admin password");

  $qry = "UPDATE $env[dbtblpasswd] SET passwd=PASSWORD('$pw1') WHERE user='admin'";
  $ret = DBQuery($qry);
  DBError();

  ErrorRedir("Admin password has been changed", "$HTTP_SERVER_VARS[PHP_SELF]");
  exit;
  exit;

} elseif ($mode == 'chpwform') {

  Head1();
  echo("<table border=0 align=center>
  <form action='$HTTP_SERVER_VARS[PHP_SELF]' method='post'>
  <tr>
    <td align=right>Current Password :</td>
    <td><input type='password' name='pw' size='12'></td>
  </tr>
  <tr>
    <td align=right>New Password :</td>
    <td><input type='password' name='pw1' size='12'></td>
  </tr>
  <tr>
    <td align=right>(repeat) :</td>
    <td><input type='password' name='pw2' size='12'></td>
  </tr>
  <tr>
    <td align=right></td>
    <td>
      <input type=hidden name=mode value='chpw'>
      <input type='submit' value='Change'>
    </td>
  </tr>
  </form></table>\n");
  Tail1();
  exit;

} elseif ($mode == 'dbstat') {
  Head1();

  $attr1 = " align='center'";
  $attr2 = " align='right'";
 echo("<table border='1' align='center'>
<tr>
  <td$attr1><b>Table</b></td>
  <td$attr1><b>Data size</b></td>
  <td$attr1><b>Index size</b></td>
  <td$attr1><b>Rows</b></td>
</tr>\n");
  $qry = "SHOW TABLE STATUS FROM $env[dbname]";
  $ret = DBQuery($qry);
  $total_data_size = $total_index_size = 0;
  while ($row = DBFetchRow($ret)) {

    $data_size = $row[Data_length];
    $index_size = $row[Index_length];

    $total_data_size  += $data_size;
    $total_index_size += $index_size;

    $rows = $row[Rows];
    list($data_size_format, $data_unit) = FormatByteDown($data_size,3,1);
    list($index_size_format, $index_unit) = FormatByteDown($index_size,3,1);

   echo("<tr>
<td align='left'><a href='$HTTP_SERVER_VARS[PHP_SELF]?mode=table_properties&table=$row[Name]'>$row[Name]</a></td>
<td$attr2>$data_size_format $data_unit</td>
<td$attr2>$index_size_format $index_unit</td>
<td$attr2>$rows</td>
</tr>\n");
  }
    list($num1, $unit1) = FormatByteDown($total_data_size,3,1);
    list($num2, $unit2) = FormatByteDown($total_index_size,3,1);
  echo("<tr>
<td align='center'><b>Total</b></td>
<td$attr2>$num1 $unit1</td>
<td$attr2>$num2 $unit2</td>
<td$attr2>N/A</td>
</tr>
</table>\n");
  Tail1();
  exit;

} elseif ($mode == 'table_properties') {
  Head1();

  $qry = "SHOW FIELDS FROM $table";
  $ret = DBQuery($qry);

  $attr1 = " align='center'";
  $attr2 = " align='right'";
  
  echo("<center>
  Properties of $table<br>
  </center>
  <table border='1' align='center'>
  <tr>
  <td$attr1><b>Field</b></td>
  <td$attr1><b>Type</b></td>
  <td$attr1><b>Default</b></td>
  <td$attr1><b>Null</b></td>
  <td$attr1><b>Extra</b></td>
  </tr>\n");

  while ($row = DBFetchRow($ret)) {
    echo("<tr>
<td$attr2>$row[Field]<br></td>
<td$attr2>$row[Type]<br></td>
<td$attr2>$row[Default]<br></td>
<td$attr2>$row[Null]<br></td>
<td$attr2>$row[Extra]<br></td>
</tr>\n");
  }
  echo("</table>\n");

  Tail1();
  exit;
}


Head1();
#echo("<script>
#function Question(msg, url) {
#  if (confirm(msg)) document.location = url;
#  else return;
#}
#</script>\n");

$attr1 = " align=center";
$attr2 = " align=center";
echo("<table border='1' align='center'>
<tr>
  <td$attr1><b>UID</b></td>
  <td$attr1><b>User name</b></td>
  <td$attr1><b>Real name</b></td>
  <td$attr1><b>Email</b></td>
  <td$attr1><b>Date</b></td>
  <td$attr1><b>Action</b></td>
</tr>\n");

$qry = "SELECT * FROM $env[dbtblpasswdtmp] ORDER BY rdate";
$ret = DBQuery($qry);
DBError();

while ($row = DBFetchRow($ret)) {
  echo("<tr>
  <td$attr2>N/A</td>
  <td$attr2>$row[user]</td>
  <td$attr2>$row[name]</td>
  <td$attr2>$row[email]</td>
  <td$attr2>$row[rdate]</td>
  <td$attr2>
    <a href=\"$HTTP_SERVER_VARS[PHP_SELF]?mode=registerform&uid=$row[uid]\">Register</a>
  </td>
  </tr>\n");
#   <a href=\"javascript:Question('Register \'$row[user]\' as a normal user?', '$HTTP_SERVER_VARS[PHP_SELF]?mode=registerform&uid=$row[uid]')\">Register</a>
}

$qry = "SELECT * FROM $env[dbtblpasswd] WHERE user!='admin' ORDER BY uid DESC";
$ret = DBQuery($qry);
DBError();

while ($row = DBFetchRow($ret)) {
  $new = (IsNew($row[rdate])) ? " <img src=../$env[icon_new] align=top>" : "";
  echo("<tr>
  <td$attr2>$row[uid]$new</td>
  <td$attr2><a href='../guestlogin.php?userid=$row[user]'>$row[user]</a></td>
  <td$attr2>$row[name]</td>
  <td$attr2>$row[email]</td>
  <td$attr2>$row[rdate]</td>
  <td$attr2>
    <a href='$HTTP_SERVER_VARS[PHP_SELF]?mode=delform&uid=$row[uid]'>Delete</a>
  </td>
  </tr>\n");
}

echo("</table>\n");

Tail1();

?>
