<?php

###############################################################
#  Database Functions
#  USAGE:
#    $result = DBQuery($qry);
#    $row = DBFetchRow($result);
#    $row = DBQueryAndFetchRow($qry);
#    $total = DBAffectedRows();
###############################################################

$pgsql_numrows= array();
$pgsql_current = array();

# for debugging
define(DBASE_ECHO_QUERY, 1);

# INPUT
#  env[dbhost]
#  env[dbuser]
#  env[dbpasswd]
#  env[dbname]
#
# STATE
#  env[connect]
#  env[num_of_query]

// ------------------------------------------------------------
// DB Error
// ------------------------------------------------------------
function DBError($debug_msg='') {
  global $env;
  $err = pg_errormessage($env[connect]);
  if ($err) {
    if ($debug_msg) echo("$debug_msg");
    echo($err);
  }
}

// ------------------------------------------------------------
// DB Connection
// ------------------------------------------------------------
function DBConnect() {
  global $env;

# $env[connect] = pg_connect($env[dbhost], "", "", "", $dbuser);
# $env[connect] = pg_connect($env[dbhost], $env[dbuser], $env[dbpasswd]);

  $env[connect] = pg_connect("host=$env[dbhost] user=$env[dbuser] password=$env[dbpasswd] dbname=$env[dbname]");
  if (!$env[connect]) { DBError("Can't connect to DB server"); }
}

// ------------------------------------------------------------
// DB Query
// ------------------------------------------------------------
function DBQuery($query) {
  global $env;
  if (DBASE_ECHO_QUERY) echo("$query<br>");
  $result = pg_exec($query);
  $env[num_of_query]++;
  return $result;
}

// ------------------------------------------------------------
// DB Fetch Row
// ------------------------------------------------------------
function DBFetchRow($ret) {
  global $pgsql_numrows;
  global $pgsql_current;

#echo("ret=$ret<br>");
  if (!isset($pgsql_numrows[$ret])) {
    $pgsql_numrows[$ret] = pg_numrows($ret);
#echo("numrows=$pgsql_numrows[$ret]<br>");

    $pgsql_current[$ret] = 0;
    $i = $pgsql_current[$ret];
    $pgsql_current[$ret]++;
  } else {
#echo("$pgsql_current[$ret] == $pgsql_numrows[$ret]<br>");
    if ($pgsql_current[$ret] == $pgsql_numrows[$ret]) {
#echo("return nothing<br>");
      return;
    }
    $i = $pgsql_current[$ret];
    $pgsql_current[$ret]++;
  }
#echo("fetch row $i<br>");

  $row = pg_fetch_array($ret, $i);
  return $row;
}

// ------------------------------------------------------------
// DB Query and Fetch Row
// ------------------------------------------------------------
function DBQueryAndFetchRow($query) {
  global $env;
  if (DBASE_ECHO_QUERY) echo("$query<br>");
  $result = pg_exec($query);
  $env[num_of_query]++;
  $row = pg_fetch_array($result, 0);
  return $row;
}

?>
