<?php

/************************************************************************/
/* Bookmark4U: Web-based personal bookmarking environment               */
/* ======================================================               */
/* Please read LICENSE.txt                                              */
/************************************************************************/

# insert a bookmark into DB
# insert a child of $parent
function InsertDB($row) {
  global $env, $lang;
  global $maxid, $exist_id;
  global $dontchange;

  # do not miss bookmark with "'" or '"' in title, url, or description
  $title = addslashes($row[title]);
  $url = addslashes($row[url]);
  $comment = addslashes($row[comment]);

  # check if the same bookmark/folder is exists
  $qry2 = "SELECT * FROM $env[userbm] WHERE parent='$row[parent]' AND title='$title' AND type='$row[type]' AND url='$url'";
  $row2 = DBQueryAndFetchRow($qry2);
  DBError();

  if ($row2) {  # if the same bookmark or folder exists
    $exist_id = $row[id];
    return 1;
  } else {
    if ($row[type] == 'b') $total = 1; else $total = 0;
    if (!$dontchange) {  # do not chage database
      $qry = "INSERT INTO $env[userbm]
          SET id='$maxid', type='$row[type]', parent='$row[parent]',
              title='$title', url='$url', comment='$comment'";
      if ($row[rdate]) $qry .= ",rdate='$row[rdate]'";
      else $qry .= ",rdate=''";
      if ($row[visit]) $qry .= ",visit='$row[visit]'";
      else $qry .= ",visit='0'";
      if ($row[public]) $qry .= ",public='$row[public]'";
      else {
        # default value comes from $env[default_public_import] (v1.7.4)
        if ($env[default_public_import] == 'private') $qry .= ",public='0'";
        else $qry .= ",public='1'"; # default value
      }
      if ($row[lastvisit]) $qry .= ",lastvisit='$row[lastvisit]'";
      else $qry .= ",lastvisit=''";
      if ($row[lastwhere]) $qry .= ",lastwhere='$row[lastwhere]'";
      else $qry .= ",lastwhere=''";
      $qry .= ",total=$total";

      $result = DBQuery($qry);
      DBError();
    }
    return 0;
  }
}

# import a bookmark file into user's DB
function NetscapeImportBookmark($userfile, $id) {
  global $env, $lang;
  global $dontchange, $maxid, $exist_id;
  global $bkcnt, $focnt;

  global $userfile;
  global $userfile_name;
  global $userfile_size;
  global $userfile_type;

# if ($userfile == "none") Error($lang[import_e1]);
# if ($userfile_size == 0) Error($lang[import_e2]);

  $bkcnt = 0;
  $focnt = 0;
  $depth = 0;
  $current = $id;
  $top = 0;

  $fp = fopen($userfile, "r");

  # compare the first line
  $buffer = fgets($fp, 4096);
  $token = "<!DOCTYPE NETSCAPE-Bookmark-file-1>";
  if (substr($buffer, 0, strlen($token)) != $token) Error($lang[import_e3]);

  echo("<ul>\n");
  # process each line
  while (!feof($fp)) {
    $buffer = fgets($fp, 4096);

    if (ereg("^[ ]*<DL", $buffer)) {  # <DL> starts a subfolder
      $depth++;
    } else if (ereg("^[ ]*<\/DL", $buffer)) {  # </DL> ends a subfolder
      echo("</ul>\n");
      if (!$dontchange) UpdateTotalLeaf($current);
      $depth--;
      $top--;
      $current = $stack[$top]; # pop current folder from stack
    } else if (ereg("^[ ]*<DT", $buffer)) { # ..<DT> defines a bookmark
      if (ereg("<A", $buffer)) {  # this is a bookmark

        $href = ereg_replace("([^H]*HREF=\")([^\"]*)(\".*)", "\\2", $buffer);
        $bktitle = ereg_replace("^( *<DT><[^>]*>)([^<]*)(.*)", "\\2", $buffer);

        # add this bookmark under the current folder
        $row = array();
        $row[parent] = $current;
        $row[type] = 'b';
        $row[title] = $bktitle;
        $row[url] = $href;
        $row[comment] = '';
        $ret = InsertDB($row);
        echo("<li><img src=$env[icon_bk]> <!--$current,$maxid-->");
        if ($ret) echo("<font color=$env[blur]>$bktitle... skip</font>"); 
        else echo("$bktitle");

        if ($ret) { # the same bookmark exists
        } else {
          $maxid++;
          $bkcnt++;
        }
      } else { # folder <DT><H3 FOLDED...>title</H3>
        $temp = $buffer;

        $folder = ereg_replace("^( *<DT><[^>]*>)([^<]*)(.*)", "\\2", $buffer);

        # push this folder name into stack
        $stack[$top] = $current;
        $top++;

        # add this folder under the current folder, and change current folder.
        $row = array();
        $row[parent] = $current;
        $row[type] = 'c';
        $row[title] = $folder;
        $row[url] = '';
        $row[comment] = '';
        $ret = InsertDB($row);
        echo("<li><img src=$env[icon_fo]> <!--$current,$maxid-->");
        if ($ret) echo("<font color=$env[blur]>$folder... skip</font>"); 
        else echo("$folder");
        echo("\n<ul>\n");

        if ($ret) { # the same folder is exist.
          $current = $exist_id;
        } else {
          $current = $maxid;
          $maxid++;
          $focnt++;
        }

      }
    }
  }

  if (!$dontchange) UpdateTotalLeaf($current);
  fclose($fp);
  echo("</ul>\n");
}

function HtmlImportBookmark($userfile, $id) {
  global $env, $lang;
  global $dontchange, $maxid, $exist_id;
  global $bkcnt, $focnt;

  global $userfile;
  global $userfile_name;
  global $userfile_size;
  global $userfile_type;

# if ($userfile == "none") Error($lang[import_e1]);
# if ($userfile_size == 0) Error($lang[import_e2]);

  $bkcnt = 0;
  $focnt = 0;
  $depth = 0;
  $current = $id;
  $top = 0;

  $fp = fopen($userfile, "r");

  # compare the first line
  $buffer = fgets($fp, 4096);

  while (!feof($fp)) {
    $buffer = fgets($fp, 4096);
  }

  fclose($fp);
}

?>
