<?php

/************************************************************************/
/* Bookmark4U: Web-based personal bookmarking environment               */
/* ======================================================               */
/* Please read LICENSE.txt                                              */
/************************************************************************/

include("inc/common.php");

if ($env[register_global_off]) {  # register get/post variables as global
  if ($HTTP_SERVER_VARS[REQUEST_METHOD] == 'GET') {
    $which_list = array('mode', 'id', 'exp', 'listfolder');
    ExtractVars($HTTP_GET_VARS, $which_list);
  } elseif ($HTTP_SERVER_VARS[REQUEST_METHOD] == 'POST') {
  }
}

CheckAuth('write');

if ($mode == 'del') {
  if (!$id) Error("Missing id");
  $qry = "DELETE FROM $env[dbtbltrash] WHERE user='$env[user]' AND id=$id";
  $ret = DBQuery($qry);
  header("Location: trash.php?dummy=$env[dummy]");
  exit;

} else if ($mode == 'delall') {
  $qry = "DELETE FROM $env[dbtbltrash] WHERE user='$env[user]'";
  $ret = DBQuery($qry);
  header("Location: trash.php?dummy=$env[dummy]");
  exit;

} else if ($mode == 'undel') {
  if (!$id) Error("Missing id");
  $qry = "SELECT * FROM $env[dbtbltrash] WHERE user='$env[user]' AND id=$id";
  $row = DBQueryAndFetchRow($qry);

  # get the parent of $id
  if ($row[parent] > 0) {
    $qry2 = "SELECT * FROM $env[userbm] WHERE id=$row[parent]";
    $row2 = DBQueryAndFetchRow($qry2);
    if (!$row2) Error("You can't restore it");
  }

  # restore
  $total = ($row[type] == 'b') ? 1 : 0;
  $qry3 = "INSERT INTO $env[userbm] SET
     id='$id', type='$row[type]', parent='$row[parent]',
     title='$row[title]', url='$row[url]', comment='$row[comment]',
     rdate=NOW(), visit='$row[visit]', public='$row[public]',
     lastvisit='$row[lastvisit]', lastwhere='$row[lastwhere]', total='0'";
  $ret3 = DBQuery($qry3);
  DBError('restore');

  # delete from trash
  $qry4 = "DELETE FROM $env[dbtbltrash] WHERE user='$env[user]' AND id=$id";
  $ret4 = DBQuery($qry4);

  # update total value
  UpdateTotalLeaf($row[parent]);

  header("Location: trash.php?dummy=$env[dummy]");
  exit;

} else if ($mode == 'info') {
  if (!$id) Error("Missing id");
  $env[title_icon] = $env[icon_trash];
  PageHead($lang[trash]);
  ButtonSet();

  $qry = "SELECT * FROM $env[dbtbltrash] WHERE user='$env[user]' AND id=$id";
  $row = DBQueryAndFetchRow($qry);
  
  $col1 = $env[th]; $aln1 = " align=right";
  $col2 = $env[td]; $aln2 = "";

  $type_str = ($row[type] == 'c') ? $lang[folder] : $lang[bookmark];
  echo("<table align=center width=90% cellpadding=3 cellspacing=1>
<tr>
  <td bgcolor=$col1 colspan=2 align=center>$lang[trash_1]</td>
</tr><tr>
  <td bgcolor=$col1$aln1>$lang[title]</td>
  <td bgcolor=$col2$aln2><b>$row[title]</b></td>
</tr><tr>
  <td bgcolor=$col1$aln1>$lang[url]</td>
  <td bgcolor=$col2$aln2><b>$row[url]</b><br>
</tr><tr>
  <td bgcolor=$col1$aln1>$lang[description]</td>
  <td bgcolor=$col2$aln2><b>$row[comment]</b></td>
</tr><tr>
  <td bgcolor=$col1$aln1>$lang[type]</td>
  <td bgcolor=$col2$aln2><b>$type_str</b></td>
</tr><tr>
  <td bgcolor=$col1$aln1>$lang[path]</td>
  <td bgcolor=$col2$aln2>");
  PrintPath($row);
  echo("</td>
</tr><tr>
  <td bgcolor=$col1$aln1>$lang[trash_2]</td>
  <td bgcolor=$col2$aln2><b>$row[ddate]</b></td>
</tr>
<tr>
  <td colspan=2 align=center bgcolor=$env[th]>
   <a href=trash.php?mode=del&id=$row[id]>$lang[delete]</a> |
   <a href=trash.php?mode=undel&id=$row[id]>$lang[restore]</a>
  </td>
</tr>
</table>\n");
  PageTail();
  exit;
}

$env[title_icon] = $env[icon_trash];
PageHead($lang[trash]);
ButtonSet();

# get the number of items in the trash
$qry = "SELECT COUNT(*) AS count FROM $env[dbtbltrash] WHERE user='$env[user]' AND type='b'";
$row = DBQueryAndFetchRow($qry);
$cnt_bk = $row[count];
$qry = "SELECT COUNT(*) AS count FROM $env[dbtbltrash] WHERE user='$env[user]' AND type='c'";
$row = DBQueryAndFetchRow($qry);
$cnt_fo = $row[count];

$qry = "SELECT * FROM $env[dbtbltrash] WHERE user='$env[user]' ORDER BY ddate DESC, title";
$ret = DBQuery($qry);

echo("<table border=0 width=100% cellpadding=2 cellspacing=1>
<tr bgcolor=$env[th]>
  <td align=center>&nbsp;&nbsp;&nbsp;&nbsp;<b>$lang[title] & $lang[url]</b></td>
  <td align=center><b>$lang[trash_2]</b></td>
  <td align=center><b>$lang[action]</b></td>
</tr>\n");

while ($row = DBFetchRow($ret)) {
  if ($row[type]=='b') $icon = $env[icon_bk];
  elseif ($row[type]=='c') $icon = $env[icon_fo];
  elseif ($row[type]=='l') $icon = $env[icon_ln];

  $title = $row[title];
  $url = $row[url];
  CutString($url, $env[cut_url]);

  if ($env[row_highlight]) {
    $attr = " onmouseover=this.style.background='$env[td]'"
           ." onmouseout=this.style.background=''";
  } else $attr = "";
  echo("<tr$attr>
  <td><img src='$icon' width='$env[icon_size_x]' height='$env[icon_size_y]' align='top'>
  <a href='trash.php?mode=info&id=$row[id]'>$title</a><br>");

  if ($row[type]=='b') {
  echo("<img src='$env[icon_trdot]' width='$env[icon_size_x]' height='$env[icon_size_y]' align='top'>
  <a href='$row[url]'>$url</a>");
  }

  echo("</td>
  <td align='center' nowrap>$row[ddate]</td>
  <td align='center' nowrap>
    <a href='trash.php?mode=del&id=$row[id]'>$lang[delete]</a><br>
    <a href='trash.php?mode=undel&id=$row[id]'>$lang[restore]</a>
  </td>
</tr>\n");
}

echo("<tr bgcolor=$env[th]>
  <td colspan='2'>
  <img src=$env[icon_fo] align=top> $cnt_fo
  <img src=$env[icon_bk] align=top> $cnt_bk
  </td>
  <td align=center>
   <a href=trash.php?mode=delall>[[$lang[trash_3]]]
  </td>
</tr>
</table>\n");

PageTail();
exit;

?>
